local i18n = QBL.i18n[QBL.locale].util.Links

QBL.util.Links = {}

-- Pre-hook ChatFrame_OnHyperlinkShow so we may intercept and display Wowhead
-- links. If a quest link is meta-clicked, Q? will ask the party to be
-- invited to it.
local _ChatFrame_OnHyperlinkShow = ChatFrame_OnHyperlinkShow
ChatFrame_OnHyperlinkShow = function(frame, link, ...)
	if type(link) == "string" and string.sub(link, 1, 8) == "Wowhead:" then
		if IsModifierKeyDown() and not QBL.var.need_quest then
			if IsInGroup() then
				-- Forces quest acceptance functions to run on requested offers.
				QBL.var.need_quest = true
				QBL:send_msg("NED" .. string.sub(link, 9))
				QBL:print(i18n.QUEST_REQ)
			else QBL:print(i18n.NO_GRP_REQ) end
		else
			local editbox = ChatEdit_GetLastActiveWindow()
			ChatEdit_ActivateChat(editbox)
			editbox:Insert("http://www.wowhead.com/quest=" .. string.sub(link, 9))
			editbox:HighlightText()
			QBL:print(i18n.LINK_HELP)
		end
	else _ChatFrame_OnHyperlinkShow(frame, link, ...) end
end

-- Returns a clickable quest URL for use with the above handler.
function QBL.util.Links.wowhead_url(idx)
	local title, level, _, _, _, _, _, quest_id = GetQuestLogTitle(idx)
	if title then
		return "|cff28B3EB|HWowhead:" .. quest_id
			.. "|h[" .. title .. " (" .. level .. ")]|h|r"
	else return "--" end
end

-- Extracts the ID from 'itemLink'.
function QBL.util.Links.get_id(link)
	if link then return select(3, string.find(link, "item:(%d+):")) end
end
